/*
 * decode
 *   Decodes rc4sniff-generated log files
 * 
 * (!c) 2001 by Ighighi
 * Venezuela
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>

#include <netinet/in.h>		/* ntohs() */
#include <arpa/inet.h>		/* inet_ntoa() */

#include "rc4.h"

/* is printable ascii ? */
#define is_ok(c)	(isascii((c)) && (isprint((c)) || isspace((c))))

#define RC4_Cryptme(x, me, ln) \
	RC4_Crypt((x), (unsigned char *) (me), (unsigned char *) (me), (ln))

#undef	min
#define min(a, b)	(((a) > (b)) ? (b) : (a))

#undef	BUFSIZE
#define BUFSIZE	1024

int main(int argc, char *argv[])
{
    char buf[BUFSIZE];    
    FILE *in, *out;
    RC4 rc4;    
    unsigned char *key;
    int i, len, minlen;
    u_int32_t src, dst;
    u_int16_t port;
    time_t logtime;
    
    if (argc != 4) {
	fprintf(stderr, "Usage: %s in-file out-file key\n", argv[0]);
	exit(1);
    }
    key = (unsigned char *) argv[3];
    
    in = fopen(argv[1], "r");
    if (! in) {
	perror(argv[1]);
	exit(1);
    }    
    out = fopen(argv[2], "w");
    if (! out) {
	perror(argv[2]);
	exit(1);
    }
    
    while (1) {
	if (fread(&logtime, 4, 1, in) != 1) break;
	if (fread(&src, 4, 1, in) != 1)	    break;
	if (fread(&dst, 4, 1, in) != 1)	    break;
	if (fread(&port, 2, 1, in) != 1)    break;	
	if (fread(&len, 2, 1, in) != 1)	    break;
	RC4_Init(&rc4, key, strlen(key));	
	RC4_Cryptme(&rc4, &logtime, 4);
	RC4_Cryptme(&rc4, &src, 4);
	RC4_Cryptme(&rc4, &dst, 4);
	RC4_Cryptme(&rc4, &port, 2);	
	RC4_Cryptme(&rc4, &len, 2);
	logtime = ntohl(logtime);
	len = ntohs(len);	
	fprintf(out, "%s -> ",
		inet_ntoa(*((struct in_addr *) &src)));
	fprintf(out, "%s (%u) %s\n",
		inet_ntoa(*((struct in_addr *) &dst)),
		ntohs(port), ctime(&logtime));

	while (len > 0) {
	    minlen = min(len, BUFSIZE);
	    if (fread(buf, minlen, 1, in) != 1) break;
	    RC4_Cryptme(&rc4, buf, minlen);
	    for (i = 0; i < minlen; i++) {
		if (! is_ok(buf[i]))
		    buf[i] = '.';
	    }
	    if (fwrite(buf, minlen, 1, out) != 1) break;
	    len -= minlen;
	}
	fputc('\n', out);
    }
    
    if (ferror(in)) {
	perror(argv[0]);
	exit(1);
    }
    
    fclose(in);
    fclose(out);
    
    exit(0);
}
